class MeBot expands Mutator;

#exec Texture Import File=Textures\0.pcx Name=RC0 Mips=Off Flags=2
#exec Texture Import File=Textures\1.pcx Name=RC1 Mips=Off Flags=2
#exec Texture Import File=Textures\2.pcx Name=RC2 Mips=Off Flags=2
#exec Texture Import File=Textures\3.pcx Name=RC3 Mips=Off Flags=2
#exec Texture Import File=Textures\4.pcx Name=RC4 Mips=Off Flags=2
#exec Texture Import File=Textures\5.pcx Name=RC5 Mips=Off Flags=2
#exec Texture Import File=Textures\6.pcx Name=RC6 Mips=Off Flags=2
#exec Texture Import File=Textures\7.pcx Name=RC7 Mips=Off Flags=2
#exec Texture Import File=Textures\8.pcx Name=RC8 Mips=Off Flags=2
#exec Texture Import File=Textures\9.pcx Name=RC9 Mips=Off Flags=2
#exec Texture Import File=Textures\10.pcx Name=RC10 Mips=Off Flags=2
#exec Texture Import File=Textures\11.pcx Name=RC11 Mips=Off Flags=2
#exec Texture Import File=Textures\12.pcx Name=RC12 Mips=Off Flags=2
#exec Texture Import File=Textures\13.pcx Name=RC13 Mips=Off Flags=2
#exec Texture Import File=Textures\14.pcx Name=RC14 Mips=Off Flags=2
#exec Texture Import File=Textures\15.pcx Name=RC15 Mips=Off Flags=2

var color clMsg;
var MonsterHunt MH;
var bool bDisabled;

event PostBeginPlay()
{
	local NavigationPoint N;
	local int NumP;

	if ( Level.Game != None )
		Level.Game.RegisterMessageMutator(Self);
	if ( MonsterHunt(Level.Game) != None )
	{
		MH = MonsterHunt(Level.Game);
		foreach AllActors (class 'NavigationPoint', N)
			NumP++;
		if ( NumP < 10 )
		{
			log ("This Level doesn't seems too rich in paths, please stop using such dumb things.");
			bDisabled = True;
		}
	}
	else
	{
		log ("This game-type is not an Original MonsterHunt");
		bDisabled=True;
	}
}

function ModifyPlayer(Pawn Other)
{
	local MHway W;
	local bool bHasTrigger;

	Super.ModifyPlayer(Other);

	if ( !bDisabled )
	if ( TournamentPlayer(Other) != None )
	{
		foreach Other.ChildActors(class'MHWay',W)
		{
			bHasTrigger=True;
			break;
		}
		if (!bHasTrigger)
		{
			W = Spawn(class'MHWay',Other,,Other.Location);
			log ("A Path Identifier has been spawned for"@Other.GetHumanName());
		}
	}
}


function Mutate(string MutateString, PlayerPawn Sender)
{
	local MHWay W;
	local bool bAbusing, bFoundTarget, bHasATarget, bWayPoint;
	local Actor Path, TheGoal, ATarget;
	local float BestWeight;
	local MonsterWayPoint Wp;
	local MonsterEnd M;
	local AltTarget At;
	local int i;

	Super.Mutate(MutateString, Sender);
	if ( Sender.Health < 1 )
	{
		Sender.ClientPlaySound(Sound'UnrealShare.BreakGlass');
		Sender.ClearProgressMessages();
		Sender.SetProgressMessage("No Shit, what's next!? Return to life first, dead pawn won't roam...",1);
		clMsg.R=255;
		clMsg.G=255;
		clMsg.B=120;
		Sender.SetProgressColor(clMsg,1);
		Sender.SetProgressTime(8);
		GoTo NoMoreAction;
	}
	if (MH == None)
	{
		Sender.ClientMessage("MHBotyMan >>> Invalid MonsterHunt Game-Type",'CriticalEvent',True);
		GoTo NoMoreAction;
	}
	if ( bDisabled )
	{
		BroadcastMessage ("MHBotyMan3 >>> I'm not bother with seeking paths in this Level.");
		BroadcastMessage ("Try another Map...");
		GoTo NoMoreAction;
	}
	if ( Caps(MutateString) ~= "HELPME" )
	{
		Sender.ClientMessage("MonsterHunt BotyMan debugger available commands (Open Console for full view or see log file):");
		Sender.ClientMessage("[mutate mytarget] - spawn a Target-Beacon that can be found later until you die.");
		Sender.ClientMessage("[mutate mypath] - find path to Target-Beacon if it's unreachable directly but available through navigation.");
		Sender.ClientMessage("[mutate mebot] - attempt to track MH A.I. mapped routes if available.");
		Sender.ClientMessage("[mutate visiblestuff] - make MonsterWaypoint(s) and MonsterEnd(s) visible if are hidden.");
		Sender.ClientMessage("[mutate hidestuff] - make MonsterWaypoint(s) and MonsterEnd(s) invisible if are not hidden.");
		Sender.ClientMessage("[mutate stopnav] - stops searching paths - it will be almost deactivated.");
//---------------------
		log("[mutate mytarget] - spawn a Target-Beacon that can be found later until you die.");
		log("[mutate mypath] - find path to Target-Beacon if available and/or Unreachable.");
		log("[mutate mebot] - attempt to track MH A.I. mapped routes if available.");
		log("[mutate visiblestuff] - make MonsterWaypoint(s) and MonsterEnd(s) visible if are hidden.");
		log("[mutate hidestuff] - make MonsterWaypoint(s) and MonsterEnd(s) invisible if are not hidden.");
		log("[mutate stopnav] - stops searching paths - it will be almost deactivated.");
		GoTo NoMoreAction;
	}

	if ( Caps(MutateString) ~= "VISIBLESTUFF" )
	{
		foreach AllActors (class 'MonsterWayPoint',Wp)
		{
			if ( Wp.bHidden )
				Wp.bHidden = False;
		}
		foreach AllActors (class 'MonsterEnd',M)
		{
			if (M.bHidden)
				M.bHidden = False;
		}
		Sender.ClientMessage("MonsterHunt BotyMan3 has received Request for Visible MH A.I. Stuff...");
	}

	if ( Caps(MutateString) ~= "HIDESTUFF" )
	{
		foreach AllActors (class 'MonsterWayPoint',Wp)
		{
			if ( !Wp.bHidden )
				Wp.bHidden = True;
		}
		foreach AllActors (class 'MonsterEnd',M)
		{
			if (!M.bHidden)
				M.bHidden = True;
		}
		Sender.ClientMessage("MonsterHunt BotyMan3 has received Request for Invisible MH A.I. Stuff...");
	}

	if ( Caps(MutateString) ~= "STOPNAV" )
	{
		Foreach AllActors (Class 'MHWay', W)
		{
			if ( W.Owner == Sender )
			{
				W.bWorking = False;
				break;
			}
		}
		Sender.ClearProgressMessages();
		Sender.SetProgressMessage("Navigation has been turned off.",1);
		clMsg.R=255;
		clMsg.G=255;
		clMsg.B=120;
		Sender.SetProgressColor(clMsg,1);
		Sender.SetProgressTime(8);
	}

	if ( Caps(MutateString) ~= "MYTARGET" )
	{
		Foreach Sender.ChildActors(class'AltTarget',At)
		{
			ATarget=At;
			bHasATarget=True;
			break;
		}
		if ( bHasATarget )
		{
			ATarget.SetLocation(Sender.Location);
			if ( ATarget != None )
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Target has been Moved at your current location... Step aside and check it.",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(8);
			}
			else
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("BORK >>> Your Target has been eliminated...",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
		}
		else
		{
			At=spawn(class'AltTarget',Sender,,Sender.Location);
			if ( At != None )
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Target has been Created at this location... Step away and see it. You can use [mutate mypath] for finding it.",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(8);
			}
			else
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Your Target could not spawn at your current location... Step aside and retry.",1);
				clMsg.R=255;
				clMsg.G=255;
				clMsg.B=120;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(8);
			}
		}
	}

	if ( Caps(MutateString) ~= "MYPATH" )
	{
		Foreach Sender.ChildActors(class'AltTarget',At)
		{
			bHasATarget=True;
			ATarget=At;
			break;
		}
		if ( bHasATarget )
		{
			Sender.Destination = ATarget.Location;
			if (Sender.ActorReachable(ATarget))
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Point is Reachable...",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
			else
			{
				Path = Sender.FindPathTo(ATarget.Location);
				if ( Path != None )
				{
					Foreach AllActors (class 'MHWay', W)
					{
						if (W.Owner == Sender)
						{
							W.TheGoal=ATarget;
							W.bWorking=True;
						}
					}
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Target-Way Navigation >> Look for the Red Circles and follow them...",1);
					clMsg.R=0;
					clMsg.G=255;
					clMsg.B=64;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
				}
				else
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Unable to find your Monster way. Wander at walls then...",1);
					clMsg.R=250;
					clMsg.G=0;
					clMsg.B=0;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
				}
			}
		}
		else
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Unable to find your Monster way. Use [mutate mytarget] command for placing a destination point.",1);
			clMsg.R=250;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
		}
	}

	if ( Caps(MutateString) ~= "MEBOT" )
	{
		clMsg.R=100;
		clMsg.G=100;
		clMsg.B=100;
		foreach AllActors (class 'MonsterWayPoint',Wp)
		{
			if ( !Wp.bVisited && Wp.Position == MH.LastPoint + 1 )
			{
				TheGoal=Wp;
				Sender.Destination = Wp.Location;
				BroadcastMessage("Found"@Wp.Name@"with Position"@Wp.Position@" >> perform Route Test...");
				if ( Sender.ActorReachable(Wp) )
				{
					bFoundTarget=True;
					break;
				}
				else if (Sender.FindPathTo(Wp.Location) != None)
				{
					bFoundTarget=True;
					break;
				}
				if (!bFoundTarget)
				{
					BroadcastMessage("No Valid route at MonsterWayPoint has been found... but we activate Navigation Mode.");
					foreach AllActors (class 'MHWay',W)
					{
						if ( W.Owner == Sender )
						{
							W.TheGoal = TheGoal;
							W.bWorking = True;
						}
					}
					bWayPoint=True;
				}
			}
		}
		if ( !bWayPoint )
		if ( !bFoundTarget )
		{
			foreach AllActors (class'MonsterEnd',M)
			{
				i++;
				TheGoal=M;
				if (Sender.ActorReachable(M))
				{
					TheGoal=M;
					bFoundTarget=True;
					break;
				}
				else if (Sender.FindPathTo(M.Location) != None)
				{
					TheGoal=M;
					bFoundTarget=True;
					break;
				}
			}
			if ( !bFoundTarget )
			{
				if (i == 1)
				{
					BroadcastMessage("No Valid reachable route to a MonsterEnd has been found... but we set active Navigation mode...");
					if (TheGoal != None)
					foreach AllActors (class 'MHWay',W)
					{
						if ( W.Owner == Sender )
						{
							W.TheGoal = TheGoal;
							W.bWorking = True;
						}
					}
				}
				else
					BroadcastMessage("No Valid reachable route to a WayPoint/MonsterEnd has been found...");
			}
		}
		if (!bFoundTarget)
		{
			Sender.ClearProgressMessages();
			Sender.SetProgressMessage("Did not find a Monster way. You can try Target Beacon - sequential checks.",1);
			clMsg.R=250;
			clMsg.G=0;
			clMsg.B=0;
			Sender.SetProgressColor(clMsg,1);
			Sender.SetProgressTime(8);
			Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
		}
		else
		{
			Sender.Destination = TheGoal.Location;
			Sender.ClientMessage("Your Destination is"@TheGoal@"from location >>"@TheGoal.Location);
			if ( Sender.ActorReachable(TheGoal))
			{
				Sender.ClearProgressMessages();
				Sender.SetProgressMessage("Destination Point is Reachable...",1);
				clMsg.R=200;
				clMsg.G=200;
				Sender.SetProgressColor(clMsg,1);
				Sender.SetProgressTime(5);
			}
			else
			{
				Path = Sender.FindPathToWard(TheGoal);
				if ( Path != None )
				{
					foreach AllActors (class 'MHWay',W)
					{
						if ( W.Owner == Sender )
						{
							W.TheGoal = TheGoal;
							W.bWorking = True;
						}
					}
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Your Monster way will be shown. Look for the Red Circles and follow them...",1);
					clMsg.R=0;
					clMsg.G=255;
					clMsg.B=64;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealI.CannonShot');
				}
				else
				{
					Sender.ClearProgressMessages();
					Sender.SetProgressMessage("Cannot Find Any Route. Check paths...",1);
					clMsg.R=240;
					clMsg.G=0;
					clMsg.B=0;
					Sender.SetProgressColor(clMsg,1);
					Sender.SetProgressTime(5);
					Sender.ClientPlaySound(Sound'UnrealShare.EndFire');
				}
			}
		}
	}
NoMoreAction:
}

DefaultProperties
{
}